﻿using System;

namespace Petzold.MusicSynthesis
{
    // Uses only integers in per-sample logic!
    public class SawtoothOscillator : IMonoSampleProvider
    {
        int sampleRate;
        uint angle;
        uint angleIncrement;

        public SawtoothOscillator(int sampleRate)
        {
            this.sampleRate = sampleRate;
        }

        public double Frequency
        {
            set
            {
                angleIncrement = (uint)(UInt32.MaxValue * value / sampleRate);
            }
            get
            {
                return (double)angleIncrement * sampleRate / UInt32.MaxValue;
            }
        }

        public short GetNextSample()
        {
            angle += angleIncrement;
            return (short)((angle >> 16) + short.MinValue);
        }
    }
}
